#include "linda.h"

static struct _TS_LIST _linda_tuplespace[SIZEOF_TS];

void
lindainit(void)
{
   int i;

   for (i = 0; i < SIZEOF_TS; i++)
       _linda_tuplespace[i].anode = _TS_NODE_NULL;
} 

void
lindaend(void)
{
	return;
}

typedef void *(*PTHREAD_FTYPE)(void *);

void
spawn(void (*f)(void *))
{
   proccreate(f, nil, Stacksize);
}

int
match(struct _INODE_LIST *inode1, struct _INODE_LIST *inode2)
{
    struct _INODE_LIST *ptr1, *ptr2;

    if((inode1 == nil) || (inode2 == nil))
		return 0;

    for (ptr1 = inode1, ptr2 = inode2; ((ptr1 != nil) && (ptr2 != nil));
         ptr1 = ptr1->next, ptr2 = ptr2->next) {

        if (ptr1->field_tag == D_FIELD) {
           if (ptr2->field_tag == D_FIELD) {
              switch (ptr1->type_tag) {
               case CHAR_TYPE:
                 if ((ptr2->type_tag != CHAR_TYPE) ||
                     (ptr1->node.c != ptr2->node.c)) return 0;
                 break;
               case CHARP_TYPE:
                 if ((ptr2->type_tag != CHARP_TYPE) ||
                     strcmp(ptr1->node.s, ptr2->node.s)) return 0;
                 break;
               case INT_TYPE:
                 if ((ptr2->type_tag != INT_TYPE) ||
                     (ptr1->node.i != ptr2->node.i)) return 0;
                 break;
               case FLOAT_TYPE:
                 if ((ptr2->type_tag != FLOAT_TYPE) ||
                     (ptr1->node.f != ptr2->node.f)) return 0;
                 break;
               default:
                 fprint(2, "Shit!\n");
                 exits("Shit!");
                 break;
              }
           } else { /* ptr2->field_tag == Q_FIELD */
              switch (ptr1->type_tag) {
               case CHAR_TYPE:
                 if (ptr2->type_tag != CHAR_TYPE) return 0;
                 break;
               case CHARP_TYPE:
                 if (ptr2->type_tag != CHARP_TYPE) return 0;
                 break;
               case INT_TYPE:
                 if (ptr2->type_tag != INT_TYPE) return 0;
                 break;
               case FLOAT_TYPE:
                 if (ptr2->type_tag != FLOAT_TYPE) return 0;
                 break;
               default:
                 fprint(2, "Shit!\n");
                 exits("Shit!");
                 break;
              }
           }
        } else { /* Q_FIELD */
           if (ptr2->field_tag == D_FIELD) {
              switch (ptr1->type_tag) {
               case CHAR_TYPE:
                 if (ptr2->type_tag != CHAR_TYPE) return 0;
                 break;
               case CHARP_TYPE:
                 if (ptr2->type_tag != CHARP_TYPE) return 0;
                 break;
               case INT_TYPE:
                 if (ptr2->type_tag != INT_TYPE) return 0;
                 break;
               case FLOAT_TYPE:
                 if (ptr2->type_tag != FLOAT_TYPE) return 0;
                 break;
               default:
                 fprint(2, "Shit!\n");
                 exits("Shit!");
                 break;
              }
           } else {
             return 0; /* Q_FIELD shouldn't match another Q_FIELD */
           }
        }
    }

    if((ptr1 == nil) && (ptr2 == nil))
		return 1;
    else
		return 0;
}

void
bindval(struct _INODE_LIST *inode1, struct _INODE_LIST *inode2)
{
    struct _INODE_LIST *ptr1, *ptr2;

    if((inode1 == nil) || (inode2 == nil))
		return;

    for(ptr1 = inode1, ptr2 = inode2; (ptr1 != nil) && (ptr2 != nil);
         ptr1 = ptr1->next, ptr2 = ptr2->next) {

        if(ptr1->field_tag == D_FIELD) {
           if(ptr2->field_tag == Q_FIELD) {
              switch(ptr1->type_tag) {
               case CHAR_TYPE:
                 *ptr2->node.cp = ptr1->node.c;
                 break;
               case CHARP_TYPE:
                 strcpy(ptr2->node.s, ptr1->node.s);
                 break;
               case INT_TYPE:
                 *ptr2->node.ip = ptr1->node.i;
                 break;
               case FLOAT_TYPE:
                 *(ptr2->node.fp) = ptr1->node.f;
                 break;
               default:
                 fprint(2, "Shit!\n");
                 exits("Shit!");
                 break;
              }
           } 
        } else { /* Q_FIELD */
           if (ptr2->field_tag == D_FIELD) {
              switch (ptr1->type_tag) {
               case CHAR_TYPE:
                 *ptr1->node.cp = ptr2->node.c;
                 break;
               case CHARP_TYPE:
                 strcpy(ptr1->node.s, ptr2->node.s);
                 break;
               case INT_TYPE:
                 *ptr1->node.ip = ptr2->node.i;
                 break;
               case FLOAT_TYPE:
                 *ptr1->node.fp = ptr2->node.f;
                 break;
               default:
                 fprint(2, "Shit!\n");
                 exits("Shit!");
                 break;
              }
           }
        }
    }
}

void
out(char *tuple_mask, ...) 
{ 
    va_list tuple_list; 
    char *mask_ptr; 
    int len, hash, i;
    struct _INODE_LIST *inode, *node_ptr;
    struct _TS_NODE *tsnode, *tsptr;
 
    len = (strlen(tuple_mask) / 2);
    hash = 0;
	inode = nil;

    tsnode = (struct _TS_NODE *)(malloc(sizeof(struct _TS_NODE)));
    tsnode->type = OUT;
    tsnode->inode = nil;

    node_ptr = nil;

    va_start(tuple_list, tuple_mask); 

    for (mask_ptr = tuple_mask, i = 1; *mask_ptr; mask_ptr+=2, i++) { 
     if (*mask_ptr == '%') {
         switch (mask_ptr[1]) { 
         case 's': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.s = va_arg(tuple_list, char *); 
           inode->type_tag = CHARP_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 3 * i;
           break;
         case 'd': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.i = va_arg(tuple_list, int); 
           inode->type_tag = INT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 5 * i;
           break;
         case 'f': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.f = va_arg(tuple_list, float); 
           inode->type_tag = FLOAT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 7 * i;
           break;
         case 'c': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.c = va_arg(tuple_list, char); 
           inode->type_tag = CHAR_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 11 * i;
           break;
         default:
           fprint(2, "Unknown type of an out.\n");
           exits("type");
         } 
     } else {
        if (*mask_ptr == '?') {
           fprint(2, "Cannot do a '?' on a out!");
           exits("?");
        }
     }

     if (tsnode->inode == nil) {
        tsnode->inode = node_ptr = inode;
     } else {
       node_ptr->next = inode;
       node_ptr = inode;
     }
    } 

    va_end(tuple_list); 

    /* Enter it into the tuple space */

    len = (len + hash) % SIZEOF_TS;
    qlock(&_linda_tuplespace[len].lock);
    
    for (tsptr = _linda_tuplespace[len].anode; tsptr != nil; 
         tsptr = tsptr->next) {

         if (match(tsnode->inode, tsptr->inode)) {
            if (tsptr->type == IN) {
               bindval(tsnode->inode, tsptr->inode);
				qunlock(&tsnode->runlock);
               goto GET_OUT;
            } else {
              if (tsptr->type == RD) {
                 bindval(tsnode->inode, tsptr->inode);
				qunlock(&tsnode->runlock);
              }
            }
         }
    }

    tsnode->next = _linda_tuplespace[len].anode;
    _linda_tuplespace[len].anode = tsnode;

GET_OUT:

    qunlock(&_linda_tuplespace[len].lock);
}

void
in(char *tuple_mask, ...) 
{ 
    va_list tuple_list; 
    char *mask_ptr; 
    int len, hash, i;
    struct _INODE_LIST *inode, *node_ptr;
    struct _TS_NODE *tsnode, *ptsptr, *tsptr;
 
    len = (strlen(tuple_mask) / 2);
    hash = 0;
	inode = nil;
    
    tsnode = (struct _TS_NODE *)(malloc(sizeof(struct _TS_NODE)));
    tsnode->type = IN;
    tsnode->inode = nil;

    node_ptr = nil;

    va_start(tuple_list, tuple_mask); 

    for (mask_ptr = tuple_mask, i = 1; *mask_ptr; mask_ptr+=2, i++) { 
     if (*mask_ptr == '%') {
         switch (mask_ptr[1]) { 
         case 's': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.s = va_arg(tuple_list, char *); 
           inode->type_tag = CHARP_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 3 * i;
           break;
         case 'd': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.i = va_arg(tuple_list, int); 
           inode->type_tag = INT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 5 * i;
           break;
         case 'f': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.f = va_arg(tuple_list, float); 
           inode->type_tag = FLOAT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 7 * i;
           break;
         case 'c': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.c = va_arg(tuple_list, char); 
           inode->type_tag = CHAR_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 11 * i;
           break;
         default:
           fprint(2, "Unknown type of an out.\n");
           exits("type");
         } 
     } else {
        if (*mask_ptr == '?') {
           switch (mask_ptr[1]) { 
            case 's': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.s = va_arg(tuple_list, char *); 
              inode->type_tag = CHARP_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 3 * i;
              break;
            case 'd': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.ip = va_arg(tuple_list, int *); 
              inode->type_tag = INT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 5 * i;
              break;
            case 'f': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.fp = va_arg(tuple_list, float *); 
              inode->type_tag = FLOAT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 7 * i;
              break;
            case 'c': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.cp = va_arg(tuple_list, char *); 
              inode->type_tag = CHAR_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 11 * i;
              break;
            default:
              fprint(2, "Unknown type of an in.\n");
              exits("type");
         }
        } else {
           fprint(2, "Don't know what it is - in ?!");
           exits("?");
        }
     }

     if (tsnode->inode == nil) {
        tsnode->inode = node_ptr = inode;
     } else {
       node_ptr->next = inode;
       node_ptr = inode;
     }
    } 

    va_end(tuple_list); 

    /* Attempt to find it in the tuple space */

    len = (len + hash) % SIZEOF_TS;
    qlock(&_linda_tuplespace[len].lock);
    
    ptsptr = nil;

    for (tsptr = _linda_tuplespace[len].anode; tsptr != nil; 
         tsptr = tsptr->next) {

         if (match(tsnode->inode, tsptr->inode)) {
            if (tsptr->type == OUT) {
               bindval(tsnode->inode, tsptr->inode);

               /* Delink the out tuple */
               if (ptsptr == nil) {
                  _linda_tuplespace[len].anode = tsptr->next;
               } else {
                  ptsptr->next = tsptr->next;
               }

               goto GET_OUT;
            } 
         }

         ptsptr = tsptr;
    }

    tsnode->next = _linda_tuplespace[len].anode;
    _linda_tuplespace[len].anode = tsnode;
	
	if(canqlock(&tsnode->runlock))
		qlock(&tsnode->runlock);
	qlock(&tsnode->runlock);
GET_OUT:

    qunlock(&_linda_tuplespace[len].lock);
}

void
rd(char *tuple_mask, ...) 
{ 
    va_list tuple_list; 
    char *mask_ptr; 
    int len, hash, i;
    struct _INODE_LIST *inode, *node_ptr;
    struct _TS_NODE *tsnode, *tsptr;
 
    len = (strlen(tuple_mask) / 2);
    hash = 0;
	inode = nil;
    
    tsnode = (struct _TS_NODE *)(malloc(sizeof(struct _TS_NODE)));
    tsnode->type = RD;
    tsnode->inode = nil;

    node_ptr = nil;

    va_start(tuple_list, tuple_mask); 

    for (mask_ptr = tuple_mask, i = 1; *mask_ptr; mask_ptr+=2, i++) { 
     if (*mask_ptr == '%') {
         switch (mask_ptr[1]) { 
         case 's': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.s = va_arg(tuple_list, char *); 
           inode->type_tag = CHARP_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 3 * i;
           break;
         case 'd': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.i = va_arg(tuple_list, int); 
           inode->type_tag = INT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 5 * i;
           break;
         case 'f': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.f = va_arg(tuple_list, float); 
           inode->type_tag = FLOAT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 7 * i;
           break;
         case 'c': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.c = va_arg(tuple_list, char); 
           inode->type_tag = CHAR_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 11 * i;
           break;
         default:
           fprint(2, "Unknown type of an out.\n");
           exits("type");
         } 
     } else {
        if (*mask_ptr == '?') {
           switch (mask_ptr[1]) { 
            case 's': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.s = va_arg(tuple_list, char *); 
              inode->type_tag = CHARP_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 3 * i;
              break;
            case 'd': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.ip = va_arg(tuple_list, int *); 
              inode->type_tag = INT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 5 * i;
              break;
            case 'f': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.fp = va_arg(tuple_list, float *); 
              inode->type_tag = FLOAT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 7 * i;
              break;
            case 'c': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.cp = va_arg(tuple_list, char *); 
              inode->type_tag = CHAR_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 11 * i;
              break;
            default:
              fprint(2, "Unknown type of an in.\n");
              exits("type");
         }
        } else {
           fprint(2, "Don't know what it is - in ?!");
           exits("?");
        }
     }

     if (tsnode->inode == nil) {
        tsnode->inode = node_ptr = inode;
     } else {
       node_ptr->next = inode;
       node_ptr = inode;
     }
    } 

    va_end(tuple_list); 

    /* Attempt to find it in the tuple space */

    len = (len + hash) % SIZEOF_TS;
    qlock(&_linda_tuplespace[len].lock);

    for (tsptr = _linda_tuplespace[len].anode; tsptr != nil; 
         tsptr = tsptr->next) {

         if (match(tsnode->inode, tsptr->inode)) {
            if (tsptr->type == OUT) {
               bindval(tsnode->inode, tsptr->inode);

               /* Don't delink the out tuple */

               goto GET_OUT;
            } 
         }
    }

    tsnode->next = _linda_tuplespace[len].anode;
    _linda_tuplespace[len].anode = tsnode;

	if(canqlock(&tsnode->runlock))
		qlock(&tsnode->runlock);
	qlock(&tsnode->runlock);
GET_OUT:

    qunlock(&_linda_tuplespace[len].lock);
}

int 
inp(char *tuple_mask, ...) 
{ 
    va_list tuple_list; 
    char *mask_ptr; 
    int len, hash, i;
    struct _INODE_LIST *inode, *node_ptr;
    struct _TS_NODE *tsnode, *ptsptr, *tsptr;
 
    len = (strlen(tuple_mask) / 2);
    hash = 0;
	inode = nil;
    
    tsnode = (struct _TS_NODE *)(malloc(sizeof(struct _TS_NODE)));
    tsnode->type = IN;
    tsnode->inode = nil;

    node_ptr = nil;

    va_start(tuple_list, tuple_mask); 

    for (mask_ptr = tuple_mask, i = 1; *mask_ptr; mask_ptr+=2, i++) { 
     if (*mask_ptr == '%') {
         switch (mask_ptr[1]) { 
         case 's': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.s = va_arg(tuple_list, char *); 
           inode->type_tag = CHARP_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 3 * i;
           break;
         case 'd': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.i = va_arg(tuple_list, int); 
           inode->type_tag = INT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 5 * i;
           break;
         case 'f': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.f = va_arg(tuple_list, float); 
           inode->type_tag = FLOAT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 7 * i;
           break;
         case 'c': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.c = va_arg(tuple_list, char); 
           inode->type_tag = CHAR_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 11 * i;
           break;
         default:
           fprint(2, "Unknown type of an out.\n");
           exits("type");
         } 
     } else {
        if (*mask_ptr == '?') {
           switch (mask_ptr[1]) { 
            case 's': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.s = va_arg(tuple_list, char *); 
              inode->type_tag = CHARP_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 3 * i;
              break;
            case 'd': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.ip = va_arg(tuple_list, int *); 
              inode->type_tag = INT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 5 * i;
              break;
            case 'f': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.fp = va_arg(tuple_list, float *); 
              inode->type_tag = FLOAT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 7 * i;
              break;
            case 'c': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.cp = va_arg(tuple_list, char *); 
              inode->type_tag = CHAR_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 11 * i;
              break;
            default:
              fprint(2, "Unknown type of an in.\n");
              exits("type");
         }
        } else {
           fprint(2, "Don't know what it is - in ?!");
           exits("?");
        }
     }

     if (tsnode->inode == nil) {
        tsnode->inode = node_ptr = inode;
     } else {
       node_ptr->next = inode;
       node_ptr = inode;
     }
    } 

    va_end(tuple_list); 

    /* Attempt to find it in the tuple space */

    len = (len + hash) % SIZEOF_TS;
    qlock(&_linda_tuplespace[len].lock);
    
    ptsptr = nil;

    for (tsptr = _linda_tuplespace[len].anode; tsptr != nil; 
         tsptr = tsptr->next) {

         if (match(tsnode->inode, tsptr->inode)) {
            if (tsptr->type == OUT) {
               bindval(tsnode->inode, tsptr->inode);

               /* Delink the out tuple */
               if (ptsptr == nil) {
                  _linda_tuplespace[len].anode = tsptr->next;
               } else {
                  ptsptr->next = tsptr->next;
               }

               qunlock(&_linda_tuplespace[len].lock);
               return 1;
            } 
         }

         ptsptr = tsptr;
    }

	qunlock(&_linda_tuplespace[len].lock);
    return 0;
}

int
rdp(char *tuple_mask, ...) 
{ 
    va_list tuple_list; 
    char *mask_ptr; 
    int len, hash, i;
    struct _INODE_LIST *inode, *node_ptr;
    struct _TS_NODE *tsnode, *tsptr;
 
    len = (strlen(tuple_mask) / 2);
    hash = 0;
	inode = nil;
    
    tsnode = (struct _TS_NODE *)(malloc(sizeof(struct _TS_NODE)));
    tsnode->type = RD;
    tsnode->inode = nil;

    node_ptr = nil;

    va_start(tuple_list, tuple_mask); 

    for (mask_ptr = tuple_mask, i = 1; *mask_ptr; mask_ptr+=2, i++) { 
     if (*mask_ptr == '%') {
         switch (mask_ptr[1]) { 
         case 's': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.s = va_arg(tuple_list, char *); 
           inode->type_tag = CHARP_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 3 * i;
           break;
         case 'd': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.i = va_arg(tuple_list, int); 
           inode->type_tag = INT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 5 * i;
           break;
         case 'f': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.f = va_arg(tuple_list, float); 
           inode->type_tag = FLOAT_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 7 * i;
           break;
         case 'c': 
           inode = 
             (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
           inode->node.c = va_arg(tuple_list, char); 
           inode->type_tag = CHAR_TYPE;
           inode->field_tag = D_FIELD;
           inode->next = nil;
           hash += 11 * i;
           break;
         default:
           fprint(2, "Unknown type of an out.\n");
           exits("type");
         } 
     } else {
        if (*mask_ptr == '?') {
           switch (mask_ptr[1]) { 
            case 's': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.s = va_arg(tuple_list, char *); 
              inode->type_tag = CHARP_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 3 * i;
              break;
            case 'd': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.ip = va_arg(tuple_list, int *); 
              inode->type_tag = INT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 5 * i;
              break;
            case 'f': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.fp = va_arg(tuple_list, float *); 
              inode->type_tag = FLOAT_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 7 * i;
              break;
            case 'c': 
              inode = 
                (struct _INODE_LIST *)(malloc(sizeof(struct _INODE_LIST)));
              inode->node.cp = va_arg(tuple_list, char *); 
              inode->type_tag = CHAR_TYPE;
              inode->field_tag = Q_FIELD;
              inode->next = nil;
              hash += 11 * i;
              break;
            default:
              fprint(2, "Unknown type of an in.\n");
              exits("type");
         }
        } else {
           fprint(2, "Don't know what it is - in ?!");
           exits("?");
        }
     }

     if (tsnode->inode == nil) {
        tsnode->inode = node_ptr = inode;
     } else {
       node_ptr->next = inode;
       node_ptr = inode;
     }
    } 

    va_end(tuple_list); 

    /* Attempt to find it in the tuple space */

    len = (len + hash) % SIZEOF_TS;
    qlock(&_linda_tuplespace[len].lock);

    for (tsptr = _linda_tuplespace[len].anode; tsptr != nil; 
         tsptr = tsptr->next) {

         if (match(tsnode->inode, tsptr->inode)) {
            if (tsptr->type == OUT) {
               bindval(tsnode->inode, tsptr->inode);

               /* Don't delink the out tuple */

               qunlock(&_linda_tuplespace[len].lock);
               return 1;
            } 
         }
    }

    qunlock(&_linda_tuplespace[len].lock);
    return 0;
}

