/*
 * Found on: http://www.comp.nus.edu.sg/~wongwf/linda.html
 */

#include <u.h>
#include <libc.h>
#include <thread.h>
 
enum {
	Stacksize = 8192,
};

#define SIZEOF_TS 100
#define MAX_NO_OF_THREADS 100

#define RD 0
#define IN 1
#define OUT 2
#define EVAL 3

#define D_FIELD 0
#define Q_FIELD 1

#define CHAR_TYPE 0
#define INT_TYPE 1
#define CHARP_TYPE 2
#define FLOAT_TYPE 3

union _INODE {
    char c, *cp;
    int i, *ip;
    char *s;
    float f, *fp;
};

struct _INODE_LIST {
    int type_tag, field_tag;
    union _INODE node;
    struct _INODE_LIST *next;
};

struct _TS_NODE {
    int type;
    QLock runlock;
    struct _INODE_LIST *inode;
    struct _TS_NODE *next;
};

struct _TS_LIST {
    QLock lock;
    struct _TS_NODE *anode;
}; 
 
#define _TS_NODE_NULL (struct _TS_NODE *)0

void lindainit(void);
void lindaend(void);
void spawn(void (*f)(void *));
void out(char *tuple_mask, ...); 
void in(char *tuple_mask, ...); 
void rd(char *tuple_mask, ...); 
int inp(char *tuple_mask, ...); 
int rdp(char *tuple_mask, ...); 
